function [] = Aspectraio_3to1()
clear all;
close all;
clc;
%%% node paramete
a=6;
b=2;
c=4;
l_node=0.5;

%%% constants
gamma     = 0.1;      % surface energy
m         = .1;       % mobility for interface migration
M         = 1000;        % mobility for diffusion
timesteps = 3600;     % number of timesteps to calculate
dt        = 0.01;     % length of each step


%%% node clean factor
MinNode   = l_node*0.4; % set minimum element length
MaxNode   = l_node*1.5; % set maximum element length


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%  2D PLOT %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Initial nodes
NN = MakeNode1(a,b,c,l_node);
x = NN(:,1);
y = NN(:,2);

%%% Plot space set up
xmin = -1*(b+c);              
xmax =  1*(b+c);             
ymin = -1;              
ymax = 1.3*a;           
tt=1;

for t = 1:timesteps;
    
    if t==1;    
        [Frames_2d(t)] = grabplot_2d(x,y,xmin,xmax,ymin,ymax);  
    end
    
    if rem(t,20)==0;
        tt=tt+1;
        [Frames_2d(tt)] = grabplot_2d(x,y,xmin,xmax,ymin,ymax);  
    end
    
    n = length(x)-1;
    [x, y] = evolve(x,y,n,gamma,m,dt, M);
    [x, y] = NodeCheck(x, y, MinNode, MaxNode);    
    
    if min(x) < -1e-3
        node_break_t = t;
        check = 1;
        break
    else check =0;
    end 
end
if check ==1;
%%% Seperate node %%%
for i = 2:n
    if x(i) < -1e-3;
        flag = i;
        break
    end
end
x1 = x(1:flag);
y1 = y(1:flag);
x2 = x(flag:end);
y2 = y(flag:end);

for t = node_break_t:timesteps;
    if rem(t,20)==0;
        tt=tt+1;
        Frames_2d(tt) = grabplot2d_2(x1,y1,x2,y2,xmin,xmax,ymin,ymax);   
    end
    
    n1 = length(x1)-1;
    n2 = length(x2)-1;
    
    [x1, y1] = evolve(x1,y1,n1,gamma,10e-5,dt,M);
    [x2, y2] = evolve(x2,y2,n2,gamma,m,dt,M);
    [x1, y1] = NodeCheck(x1, y1, MinNode, MaxNode);
    [x2, y2] = NodeCheck(x2, y2, MinNode, MaxNode);
end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%  3D PLOT %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Initial nodes
NN = MakeNode1(a,b,c,l_node);
x = NN(:,1);
y = NN(:,2);

%%% Plot space set up
xmin = -1*(b+c);              
xmax =  1*(b+c);             
ymin = -1;              
ymax = 1.3*a;           
tt=1;

for t = 1:timesteps;
    
    if t==1;    
        [Frames_3d(t)] = grabplot_3d(x,y,xmin,xmax,ymin,ymax);  
    end
    
    if rem(t,20)==0;
        tt=tt+1;
        [Frames_3d(tt)] = grabplot_3d(x,y,xmin,xmax,ymin,ymax);  
    end
    
    n = length(x)-1;
    [x, y] = evolve(x,y,n,gamma,m,dt, M);
    [x, y] = NodeCheck(x, y, MinNode, MaxNode);    
    
    if min(x) < -1e-3
        node_break_t = t;
        check = 1;
        break
    else check =0;
    end 
end

if check==1;
%%% Seperate node %%%
for i = 2:n
    if x(i) < -1e-3;
        flag = i;
        break
    end
end
x1 = x(1:flag);
y1 = y(1:flag);
x2 = x(flag:end);
y2 = y(flag:end);

for t = node_break_t:timesteps;
    if rem(t,20)==0;
        tt=tt+1;
        Frames_3d(tt) = grabplot3d_2(x1,y1,x2,y2,xmin,xmax,ymin,ymax);   
    end
    
    n1 = length(x1)-1;
    n2 = length(x2)-1;
    
    [x1, y1] = evolve(x1,y1,n1,gamma,10e-5,dt,M);
    [x2, y2] = evolve(x2,y2,n2,gamma,m,dt,M);
    [x1, y1] = NodeCheck(x1, y1, MinNode, MaxNode);
    [x2, y2] = NodeCheck(x2, y2, MinNode, MaxNode);
end
end

movie2avi(Frames_2d,'Aspectratio_3to1_2d.avi','quality',100);
movie2avi(Frames_3d,'Aspectratio_3to1_3d.avi','quality',100);

end