
function [x y] = NodeCheck(x,y,MinLength,MaxLength)

n = length(x);

% Find elements that are too small
flag = 0;
for i = 1:n-2
    if ((x(i+1-flag)-x(i-flag))^2+(y(i+1-flag)-y(i-flag))^2)^(1/2) < MinLength

        % Delete extra nodal point
        x(i+1-flag) = [];
        y(i+1-flag) = [];

        % fix indices
        i = i+1;
        flag = flag +1;
    end
end

% Find new number of nodal points
n = length(x);

% find elements that are too big
for i = 2:n
    if ((x(i)-x(i-1))^2+(y(i)-y(i-1))^2)^(1/2) > MaxLength
    
        if((x(i)-x(i-1))^2+(y(i)-y(i-1))^2)^(1/2) < 3* MaxLength
            
        % pick a new x location
        newx = (x(i)+x(i-1))/2;
        newy = (y(i)+y(i-1))/2;

        % Build new list of nodal points
        xtemp = zeros(1,length(x)+1);
        xtemp(1:i-1)= x(1:i-1);
        xtemp(i) = newx;
        xtemp(i+1:end) = x(i:end);

        ytemp = zeros(1,length(y)+1);
        ytemp(1:i-1)= y(1:i-1);
        ytemp(i) = newy;
        ytemp(i+1:end) = y(i:end);

        % Update nodal points
        x = xtemp;
        y = ytemp;

        % Adjust loop index
        i=i-1; 
        end
    end    
end


%%% Eliminate concurrent element
if x(2) < 1e-3
    x(1)=[];
    y(1)=[];
    x(1)=0;
end

if x(end-1) < 1e-3
    x(end)=[];
    y(end)=[];
    x(end)=0;
end

end 