function [x, y] = evolve( x, y, n, gamma,m, dt, M)

H = zeros(4*n+3,4*n+3);
Hl = zeros(4);
f = zeros(4*n+3,1);
fl = zeros(4,1);
theta = zeros(n,1);
l = zeros(n,1);

for i = 1:n
    l(i) = ((x(i+1)-x(i))^2+(y(i+1)-y(i))^2)^(1/2); % element length
    theta(i) = asin((y(i+1)-y(i))/l(i)); % angle
    if x(i+1) < x(i)
        theta(i)=pi-theta(i);
    end
end

for j=1:n;
    
    L = l(j);
    S = sin(theta(j));
    C = cos(theta(j));    
    x1 = x(j);
    x2 = x(j+1);
    ms = m;
    Ms = M;
 

    %%% Local H matrix components
    Hl(1,1) = (pi*L*S^2/(30*ms))*(10*x1^3+6*x1^2*x2+3*x1*x2^2+x2^3);
    Hl(1,2) = (-pi*L*C*S/(30*ms))*(10*x1^3+6*x1^2*x2+3*x1*x2^2+x2^3);
    Hl(1,3) = (pi*S/(30*ms))*(4*x1+x2)*(-2*C*L*x1+7*x1^2+2*x1*x2+x2^2);
    Hl(1,4) = (pi*L*S^2/(30*ms))*(2*x1^3+3*x1^2*x2+3*x1*x2^2+2*x2^3);
    Hl(1,5) = (-pi*L*C*S/(30*ms))*(2*x1^3+3*x1^2*x2+3*x1*x2^2+2*x2^3);
    Hl(1,6) = (pi*S/(30*ms))*(C*L*x1^2+4*x1^3-3*x1^2*x2-C*L*x2^2-6*x1*x2^2-5*x2^3);
    Hl(1,7) = (2*pi*S/(15*ms))*(-2*C*L*x1^2-8*x1^3-2*C*L*x1*x2-3*x1^2*x2-C*L*x2^2+x2^3);
    Hl(2,2) = (pi*L*C^2/(30*ms))*(10*x1^3+6*x1^2*x2+3*x1*x2^2+x2^3);
    Hl(2,3) = (pi*C/(30*ms))*(4*x1+x2)*(2*C*L*x1-7*x1^2-2*x1*x2-x2^2);
    Hl(2,4) = (-pi*L*C*S/(30*ms))*(2*x1^3+3*x1^2*x2+3*x1*x2^2+2*x2^3);
    Hl(2,5) = (pi*L*C^2/(30*ms))*(2*x1^3+3*x1^2*x2+3*x1*x2^2+2*x2^3);
    Hl(2,6) = (-pi*C/(30*ms))*(C*L*x1^2+4*x1^3-3*x1^2*x2-C*L*x2^2-6*x1*x2^2-5*x2^3);
    Hl(2,7) = (2*pi*C/(15*ms))*(2*C*L*x1^2+8*x1^3+2*C*L*x1*x2+3*x1^2*x2+C*L*x2^2-x2^3);
    Hl(3,3) = (pi*L/(30*Ms))*(7*x1+x2)+(pi/(30*ms*L))*(7*C^2*L^2*x1*x1-46*C*L*x1^2+79*x1^3+C^2*L^2*x2-12*C*L*x1*x2+39*x1^2*x2-2*C*L*x2^2+15*x1*x2^2+7*x2^3);
    Hl(3,4) = (pi*S/(30*ms))*(-C*L*x1^2+5*x1^3+6*x1^2*x2+C*L*x2^2+3*x1*x2^2-4*x2^3);
    Hl(3,5) = (-pi*C/(30*ms))*(-C*L*x1^2+5*x1^3+6*x1^2*x2+C*L*x2^2+3*x1*x2^2-4*x2^3);
    Hl(3,6) = (-pi*L*(x1+x2)/(30*Ms))+(pi*(x1+x2)/(30*ms*L))*(-C^2*L^2-2*C*L*x1+13*x1^2+2*C*L*x2-16*C*L*x2+13*x2^2);
    Hl(3,7) = (2*pi*L*x1/(15*Ms))+ (2*pi/(15*ms*L))*(C^2*L^2*x1+2*C*L*x1^2-23*x1^3-2*C*L*x1*x2-9*x1^2*x2-3*x1*x2^2-5*x2^3);
    Hl(4,4) = (pi*L*S^2/(30*ms))*(x1^3+3*x1^2*x2+6*x1*x2^2+10*x2^3);
    Hl(4,5) = (-pi*L*C*S/(30*ms))*(x1^3+3*x1^2*x2+6*x1*x2^2+10*x2^3);
    Hl(4,6) = (-pi*S/(30*ms))*(x1+4*x2)*(x1^2+2*C*L*x2+2*x1*x2+7*x2^2);
    Hl(4,7) = (2*pi*S/(15*ms))*(-C*L*x1^2-x1^3-2*C*L*x1*x2-2*C*L*x2^2+3*x1^2*x2+8*x2^3);
    Hl(5,5) = (pi*L*C^2/(30*ms))*(x1^3+3*x1^2*x2+6*x1*x2^2+10*x2^3);
    Hl(5,6) = pi*C*(x1+4*x2)*(x1^2+2*C*L*x2+2*x1*x2+7*x2^2)/30/ms;
    Hl(5,7) = 2*pi*C*(C*L*x1^2+x1^3+2*C*L*x1*x2+2*C*L*x2^2-3*x1*x2-8*x2^3)/15/ms;
    Hl(6,6) = pi*L*(x1+7*x2)/30/Ms + pi*(C^2*L^2*x1+2*C*L*x1^2+7*x1^3+7*C^2*L^2*x2+12*C*L*x1*x2+15*x1^2*x2+46*C*L*x2^2+39*x1*x2^2+79*x2^3)/30/ms/L;
    Hl(6,7) = 2*pi*L*x2/15/Ms + 2*pi*(-5*x1^3+C^2*L^2*x2+2*C*L*x1*x2-3*x1^2*x2-2*C*L*x2^2-9*x1*x2^2-23*x2^3)/15/ms/L;
    Hl(7,7) = 8*pi*L*(x1+x2)/15/Ms + 8*pi*(x1+x2)*(C^2*L^2+2*C*L*x1+7*x1^2-2*C*L*x2-4*x1*x2+7*x2^2)/15/ms/L;
    %%% H matrix symmetry
    for ii=2:7
        for iii=1:ii-1
            Hl(ii,iii) = Hl(iii,ii);
        end
    end
    Hl(1,1)=1+Hl(1,1); Hl(2,2)=1+Hl(2,2);Hl(4,4)=1+Hl(4,4);Hl(5,5)=1+Hl(5,5);

    %%% COnstruct global H matrix
    if j==1
        for js=1:7
            for ks=1:7
                H(js,ks)=Hl(js,ks);
            end
        end
    else
        for js=0:2
            for ks=0:2
                H(4*j+js-4,4*j+ks-4)=Hl(js+1,ks+1)+H(4*j+js-4,4*j+ks-4);
            end
        end
        for js=0:2
            for ks=4:7
                H(4*j+js-4,4*j+ks-4)=Hl(js+1,ks);
                H(4*j+ks-4,4*j+js-4)=Hl(ks,js+1);
            end
        end
        for js=4:7
            for ks=4:7
                H(4*j+js-4,4*j+ks-4)=Hl(js,ks);
            end
        end
    end
    
    %%% Local Force vector
    fl(1)=gamma*pi*(-L+(x1+x2)*C);
    fl(2)=gamma*pi*((x1+x2)*S);
    fl(3)=gamma*pi*(-L-(x1+x2)*C);
    fl(4)=gamma*pi*(-(x1+x2)*S);

    %%% Global force vector
    if j==1
        f(1)=fl(1);
        f(2)=fl(2);
        f(4)=fl(3);
        f(5)=fl(4);
    else
        f(4*j-4)=fl(1)+f(4*j-4);
        f(4*j-3)=fl(2)+f(4*j-3);
        f(4*j)=fl(3);
        f(4*j+1)=fl(4);  
    end
end

%%% Boundary Condition
H(end-3,end-3) = 1E5;  %fix the last point in x direction
H(1,1) = 1E5;          %fix the first point in x direction

vel=H\f;

%%% Time evolusion with Euler Method
for i=1:(n+1);
    if i==1
        x(i)=x(i)+ vel(2*i-1)*dt;
        y(i)=y(i)+ vel(2*i)*dt;
    else
        x(i)=x(i)+ vel(4*i-4)*dt;
        y(i)=y(i)+ vel(4*i-3)*dt;
    end
       
end
end
